import argparse
import torch
import os

class Args(argparse.Namespace):
    single_cls = False
opt = Args()

device = "cuda" if torch.cuda.is_available() else "cpu"
WEIGHT_NAME = 'yolovr_dv3p1g_norm'
TEACHER_PATH = f'runs/weight/{WEIGHT_NAME}/best.pt'
STUDENT_PATH = f'runs/weight/{WEIGHT_NAME}_student'
TS_MODEL = 'cfg/training/yolov7-ts-gpt.yaml'
Layer_DEEP = 37
STUDENT_SIZE = 512
teacher_weight = torch.load(TEACHER_PATH)
teacher_dict_weight = teacher_weight['model'].model[Layer_DEEP].D.weight
student_dict_weight = teacher_dict_weight[:, :512]
torch.save(teacher_dict_weight, 'dict_init/teacher.pt')
torch.save(student_dict_weight, 'dict_init/student.pt')
import torch
from models.yolo import Model
from utils.torch_utils import intersect_dicts

device = torch.device('cuda')
model = Model(TS_MODEL, ch=3, nc=80).to(device)  # create
state_dict = teacher_weight['model'].float().state_dict()  # to FP32
state_dict = intersect_dicts(state_dict, model.state_dict(), exclude=['anchor'])
model.load_state_dict(state_dict, strict=False)  # load
print('Transferred %g/%g items from' % (len(state_dict), len(model.state_dict())))
torch.save({'model': model, 'optimizer': None, 'epoch': 0}, 'ts-gpt.pt')
